;void  box_color(col,row,width,depth,color);
;  unsigned char  col,row,width,depth,color;

	EXTRN  _memory_model:byte
	EXTRN  _video_buffer:word
	EXTRN  _snow_protect:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _box_color
_box_color proc near
	cld			;direction flag forward
	push bp			;
	mov  bp,sp		;set stack frame
	push di			;
	push si			;
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	mov  ax,_video_buffer	;fetch _video_buffer
	mov  es,ax		;place in ES
	sub  ax,ax		;
	mov  al,[bp+6]		;get row
	dec  ax			;count from 0
	mov  dl,160		;bytes per row
	mul  dl			;times rows
	sub  dx,dx		;
	mov  dl,[bp+4]		;get column
	dec  dx			;count from 0
	shl  dx,1		;double for attributes
	add  ax,dx		;add to row offset
	mov  si,ax		;ES:DI pts to first char
	inc  si			;shift to first attribute
	sub  bx,bx		;
	mov  bl,[bp+8]		;width in BX
	or   bx,bx		;test for zero
	jz   L6			;quit if zero
	sub  dx,dx		;
	mov  dl,[bp+10]		;depth in DX
	or   dx,dx		;test for zero
	jz   L6			;quit if zero
	mov  al,[bp+12]		;attribute in AL
L1:	mov  cx,bx		;width to CX as counter
	mov  di,si		;move ptr to DI
	push dx			;save depth counter
L2:	mov  dx,es		;get video buffer address
	cmp  _snow_protect,0	;protect against snow?
	je   L5			;jump if not
	mov  dx,3dah		;status byte address
	mov  bp,ax		;save AX contents
L3:	in   al,dx		;get status byte
	test al,1		;test bit
	jnz  L3			;loop till 0
	cli			;disable interrupts
L4:	in   al,dx		;get status byte
	test al,1		;test bit
	jz   L4			;loop till 1
	mov  ax,bp		;restore AX contents
L5:	stosb			;write an attribute byte
	inc  di			;pt to next attri byte
	loop L2			;go do next attri in line
	pop  dx			;restore DX
	dec  dx			;dec row counter
	jz   L6			;quit if finished
	add  si,160		;move ptr forward 1 row
	jmp  short L1		;go do next row
L6:	pop  si			;
	pop  di			;
	pop  bp			;
	sti			;reenable interrupts
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_box_color endp
_TEXT	ENDS
	END
