;void  row_color(col,row,width,color);
;  unsigned char  col,row,width,color;


	EXTRN  _memory_model:byte
	EXTRN  _video_buffer:word
	EXTRN  _snow_protect:byte

_TEXT	SEGMENT BYTE PUBLIC 'CODE'
	ASSUME CS:_TEXT
	PUBLIC _row_color
_row_color proc near
	push bp			;
	mov  bp,sp		;set stack frame
	push di			;
	cmp  _memory_model,0	;near or far?
	jle  begin		;jump if near
	inc  bp			;else add 2 to BP
	inc  bp			;
begin:	mov  ax,_video_buffer	;segment of _video_buffer
	mov  es,ax		;move to ES
	sub  ax,ax		;
	mov  al,[bp+4]		;get Col value
	mov  di,ax		;
	dec  di			;count from 0
	mov  al,[bp+6]		;get Row value
	dec  ax			;count from 0
	mov  dl,160		;bytes per row
	mul  dl			;times number rows
	shl  di,1		;double for attri bytes
	add  di,ax		;add Row offset
	inc  di			;ES:DI pts to 1st attri
	sub  cx,cx		;
	mov  cl,[bp+8]		;width
	jcxz L5			;quit if null
	mov  al,[bp+10]		;attribute in AL
	cld			;direction flag forward
L1:	cmp  _snow_protect,0	;protect against snow?
	je   L4			;jump if not
	mov  dx,3dah		;status byte address
	mov  bx,ax		;save ax contents
L2:	in   al,dx		;get status byte
	test al,1		;test bit
	jnz  L2			;loop till 0
	cli			;disable interrupts
L3:	in   al,dx		;get status byte
	test al,1		;test bit
	jz   L3			;loop till 1
	mov  ax,bx		;restore AX contents
L4:	stosb			;change attri of 1 char
	inc  di			;skip pointer over next
	loop L1			;go change next attribute
L5:	sti			;reenable interrupts
	pop  di			;
	pop  bp			;
	cmp  _memory_model,0	;quit
	jle  quit		;
	db   0CBh		;RET far
quit:	ret			;RET near
_row_color endp
_TEXT	ENDS
	END
